# Source Generated with Decompyle++
# File: in.pyc (Python 1.5)

import Bladex
import darfuncs

def LaunchMusicEvent(musicname):
    Bladex.ExeMusicEvent(Bladex.GetMusicEvent(musicname))

AsociatedMusic = { }

def OnEnterSectorMusic(id):
    if AsociatedMusic.has_key(id):
        music = AsociatedMusic[id]
        Bladex.AddScheduledFunc(Bladex.GetTime(), LaunchMusicEvent, (music,))
    else:
        music = None
    for key in AsociatedMusic.keys():
        pass
    


def Music2Sector(sec, music):
    id = darfuncs.GetSectorIdx(sec)
    if not AsociatedMusic.has_key(id):
        darfuncs.EnterSecIdEvent(id, OnEnterSectorMusic)
    
    if music:
        AsociatedMusic[id] = music
    elif AsociatedMusic.has_key(id):
        del AsociatedMusic[id]
    

MusicChanges = { }

def OnEnterMusicChange(id):
    for mtr in MusicChanges[id]:
        pass
    
    del MusicChanges[id]
    for key in MusicChanges.keys():
        darfuncs.EnterSecIdEvent(key, OnEnterMusicChange)
    


def ModifyMusicEvent(sec, tarsec, music = None):
    id = darfuncs.GetSectorIdx(sec)
    ev = (darfuncs.GetSectorIdx(tarsec), music)
    if not MusicChanges.has_key(id):
        MusicChanges[id] = [
            ev]
        darfuncs.EnterSecIdEvent(id, OnEnterMusicChange)
    else:
        MusicChanges[id].append(ev)


def AddPrelude(sec, Prelude):
    id = darfuncs.GetSectorIdx(sec)
    ev = (Prelude,)
    if not MusicChanges.has_key(id):
        MusicChanges[id] = [
            ev]
        darfuncs.EnterSecIdEvent(id, OnEnterMusicChange)
    else:
        MusicChanges[id].append(ev)


def SaveData(filename):
    import cPickle
    funcfile = open(filename, 'wt')
    p = cPickle.Pickler(funcfile)
    d = (AsociatedMusic, MusicChanges)
    p.dump(d)
    funcfile.close()


def LoadData(filename):
    global AsociatedMusic, MusicChanges
    import cPickle
    funcfile = open(filename, 'rt')
    p = cPickle.Unpickler(funcfile)
    d = p.load()
    funcfile.close()
    print d
    AsociatedMusic = d[0]
    MusicChanges = d[1]

import GameState
GameState.ModulesToBeSaved.append(__import__(__name__))
